property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "Calendar"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20Calendar%20(v" & script_version & ")"
property script_contribution_url : "https://order.kagi.com/?ELJ"

property first_run : true
property run_plead : false
property the_data_source : missing value

--localize these values:
property all_months : {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}
property all_days : {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "calendar"
	if first_run then display window "license" attached to window "calendar"
end launched

on should quit after last window closed the_object
	if (visible of window "calendar") then return false
	my quit_prep()
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "calendar" then
		tell the_object
			set hides when deactivated to false
			if first_run then center
			set cd to (current date)
			set the_month to (month of cd as integer)
			set the_year to (year of cd)
			set the_data_source to data source of table view 1 of scroll view 1
			tell the_data_source
				repeat with this_day in all_days
					make new data column at end of data columns with properties {name:(contents of this_day)}
				end repeat
			end tell
			tell table view 1 of scroll view 1
				repeat with i from 1 to (count all_days)
					set title of header cell of table column i to (character 1 of (item i of all_days))
				end repeat
			end tell
			my update_cal(the_month, the_year)
			tell menu of popup button "the_month"
				try
					delete menu items
				end try
				repeat with this_month in all_months
					make new menu item at end with properties {title:(contents of this_month)}
				end repeat
			end tell
			set title of popup button "the_month" to (item the_month of all_months)
			set integer value of stepper "the_year" to the_year
			set contents of text field "the_year" to the_year
			update
		end tell
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
				set state of button "run_plead" to (run_plead as integer)
			end tell
		end tell
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "calendar"
		
	else if object_name = "quit" then
		my quit_prep()
		quit
		
	else if object_name = "the_month" then
		my get_chosen_month_and_year()
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "contribute" then
		open location script_contribution_url
		
	else if object_name = "run_plead" then
		set run_plead to true
		if state of the_object = 0 then set run_plead to false
		my write_settings()
		
	else if object_name = "the_year" then
		my get_chosen_month_and_year()
		
	else if object_name = "today" then
		set cd to (current date)
		set the_month to (month of cd as integer)
		set the_year to (year of cd)
		tell window of the_object
			set title of popup button "the_month" to (item the_month of all_months)
			set integer value of stepper "the_year" to the_year
			set contents of text field "the_year" to the_year
			update
		end tell
		my update_cal(the_month, the_year)
		
	end if
end clicked

on action the_object
	set object_name to name of the_object as Unicode text
	my update_status("action " & object_name)
end action

on will open the_object
	try
		set {x, y} to (get size of window "calendar")
	end try
	return true
end will open

on idle the_object
	return 1
end idle

on end editing the_object
	set object_name to name of the_object as Unicode text
	my update_status("end editing " & object_name)
	try
		set the_year to (get content of the_object) as integer
		set contents of stepper "the_year" of window of the_object to the_year
		my get_chosen_month_and_year()
	on error the_error
		my update_status(the_error)
	end try
end end editing

on quit_prep()
	set panel_wins to name of (windows whose class = panel and visible = true)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
	my write_settings()
	if run_plead then my plead()
	set quitting to true
end quit_prep

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		make new default entry at end of default entries with properties {name:"run_plead", contents:run_plead}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
		set run_plead to contents of default entry "run_plead"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
		set contents of default entry "run_plead" to run_plead
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status

on plead()
	activate
	if button returned of (display dialog "I hope you found this useful. If so, please consider contributing to my webhosting and general development costs. (See the About box to disable this reminder.)" buttons {"Later", "Now"} default button 2 with icon 1) = "Now" then open location script_contribution_url
end plead

on get_chosen_month_and_year()
	tell window "calendar"
		set the_month to title of popup button "the_month"
		set the_year to integer value of stepper "the_year"
	end tell
	repeat with i from 1 to (count all_months)
		if (item i of all_months) = the_month then exit repeat
	end repeat
	my update_cal(i, the_year)
end get_chosen_month_and_year

on get_cal(the_month, the_year)
	return (do shell script "cal " & the_month & " " & the_year & " | tr -s ' '")
end get_cal

on update_cal(the_month, the_year)
	my update_status({the_month, the_year})
	tell window "calendar"
		set contents of text field "the_year" to the_year
		update
	end tell
	try
		tell the_data_source to delete data rows
	end try
	set current_month to paragraphs of (my get_cal(the_month, the_year))
	set all_weeks to {}
	tell (a reference to my text item delimiters) to set {contents, old_delim, contents} to {"", contents, " "}
	repeat with i from 3 to (count current_month)
		set the_week to (text items of item i of current_month)
		try
			if item 1 of the_week = "" then set the_week to (items 2 thru -1 of the_week)
			if i = 3 then
				repeat while (count of the_week)  7
					set beginning of the_week to ""
				end repeat
			end if
			set end of all_weeks to the_week
		end try
	end repeat
	set my text item delimiters to old_delim
	append the_data_source with all_weeks
end update_cal